<template>
    <el-table
        :data="data"
        :border="true"
        @sort-change="sortHandler"
        :default-sort="sortParams"
        :cell-class-name="setCellClass"
        :row-class-name="setRowClass"
        :highlight-current-row="highlightCurrentRow"
    >
        <el-table-column
            v-for="(propObj, propKey) in tableStructure"
            :key="propKey"
            :prop="propKey"
            :label="propObj.title"
            :sortable="propObj.sortable"
            :resizable="true"
            :min-width="!propObj.width ? 120 : propObj.width"
            :sort-orders="['ascending', 'descending']"
        >
            <template v-slot="{ row }">
                <!--no data from server or data is empty-->
                <n-a v-if="isEmpty(row[propKey], propObj.default_value)"/>
                <!--icon for column-->
                <div v-else-if="needIcon(propKey, row[propKey], propObj)" class="icon">
                    <i :class="row[propKey] | status_icon"></i>
                </div>
                <div v-else-if="propObj.dictionary && dictionary[propObj.dictionary]">
                        {{labelsFromDictionary(propObj, row[propKey])}}
                </div>
                <!--link for column-->
                <div v-else-if="propObj.link && !isEmpty(row[propKey], propObj.default_value)">
                    <router-link v-if="propObj.link.base" :to="`${propObj.link.base}${propObj.link.param ? row[propObj.link.param] : row[propKey]}`">
                        <div class="link word_break">{{row[propKey]}}</div>
                    </router-link>
                    <a v-else-if="propObj.link.url_param" :href="`${row[propObj.link.url_param]}`" target='_blank' :referrer="$route.meta.href">
                        <div class="link word_break">{{linkRow(row[propKey], { default_value: propObj.default_value } )}}</div>
                    </a>
                </div>
                <!--complex link for column (from wrapped server data) -->
                <div v-else-if="propObj.complex && typeof row[propKey]==='object'">
                    <a v-if="propObj.complex.url" :href="`${row[propKey][propObj.complex.url]}`" target='_blank' :referrer="$route.meta.href">
                        <div class="link word_break">{{linkRow(row[propKey], propObj.complex)}}</div>
                    </a>
                </div>
                <!--text for column-->
                <div v-else :class="isSpaceBreak(propKey)">{{dynamicFilter(row[propKey], propObj.filter)}}</div>
            </template>
        </el-table-column>
    </el-table>
</template>

<script>
import dynamicFilterMixin from '@/mixins/dynamicFilterMixin';
import { NoAnswer as NA } from '@bloomio/spa-admin-common/components';
import { mapState } from 'vuex';

export default {
    components: {
        NA,
    },
    props: {
        /** table settings */
        tableStructure: {
            type: Object,
            required: true,
        },
        /** table content data */
        data: {
            type: Array,
            required: false,
            default: () => [],
        },
        /** table sort params */
        sortParams: {
            type: Object,
            required: false,
            default: () => {},
        },
        /** select current table row on click */
        highlightCurrentRow: {
            type: Boolean,
            required: false,
            default: false,
        },
    },
    mixins: [dynamicFilterMixin],
    computed: {
        noSpaceBreak: () => ['email', 'domain'],
        needIcon: () => (id, value, conf) => (value !== '' && (['confirmed', 'onboarding'].indexOf(id) > -1 || (conf && conf.is_status_icon))),
        linkRow: vm => (data, paramsObj) => {
            if (!data && paramsObj.default_value) {
                return paramsObj.default_value;
            }
            if (paramsObj.content) {
                if (typeof paramsObj.content === 'string') {
                    return vm.dynamicFilter(data[paramsObj.content], paramsObj.filter);
                }
                if (typeof paramsObj.content === 'object') {
                    return Object.keys(paramsObj.content).reduce((acc, key) => {
                        acc.push(`${vm.dynamicFilter(data[key], paramsObj.content[key].filter)}`);
                        return acc;
                    }, []).join('\n');
                }
            }
            return data;
        },
        isSpaceBreak: vm => key => (vm.noSpaceBreak.indexOf(key) === -1 ? 'word_break' : ''),
        isEmpty: () => (val, defaultVal) => (val === null || ([undefined, '', null].includes(val) && !defaultVal)),
        ...mapState({
            dictionary: state => state.users.filter_dictionary,
        }),
        labelsFromDictionary: vm => (conf, val) => {
            const dict = vm.dictionary[conf.dictionary];
            let res = [];
            if (Array.isArray(val)) { // multiple values
                res = val.reduce((acc, cur) => {
                    const found = dict.find(el => el.value === cur);
                    if (found) {
                        acc.push(found.label);
                    }
                    return acc;
                }, []);
            } else { // single value from dictionary
                const temp = dict.find(el => el.value === val);
                res = temp ? temp.label : '';
            }
            return (conf.filter ? vm.$filters[conf.filter](res) : res);
        },
    },
    methods: {
        /** dispatch event on changing sorting column */
        sortHandler(event) {
            this.$emit('sort-change', event);
        },
        /**
         * set specific cell class for application column
         * @param {Object} cellData - current cell params: {row, column, rowIndex, columnIndex}
         * @returns {String} custom class name for a cell
         */
        setCellClass({ row, column }) {
            if (column.property === 'application' && row.application.status) {
                return row.application.status.toLowerCase().split(' ').join('_');
            }
            return '';
        },
        /**
         * Set row class name (to highlight some rows)
         * @returns {String} class name
         */
        setRowClass({ row }) {
            return ([row.is_dd, row.is_active].includes(false) || ['', null, false].includes(row.public_profile)) ? 'not_active' : '';
        },
    },
};
</script>

<style lang="stylus" scoped>
.el-table
    margin-bottom: 2rem
    width: 100%

>>> td
    border: none

>>> .not_active
    background-color: rgba($light_gray, 0.7)

.icon
    margin-left: 1rem

.word_break
    word-break: normal
    white-space pre-wrap

</style>
